6000 REM subroutines priplo control *******************************************
6020 REM controls used in textmode ****
6030 REM set priplo to textmode -----------------------------------------------
6040 I= 1: GOSUB 10000: REM textmode
6090 RETURN
6100 REM set priplo to graphicmode --------------------------------------------
6120 I= 2: GOSUB 10000: REM graphic
6190 RETURN
6200 REM line up --------------------------------------------------------------
6220 I= 3: GOSUB 10000: REM line up
6290 RETURN
6300 REM pen test -------------------------------------------------------------
6320 I= 4: GOSUB 10000: REM draw pattern
6390 RETURN
6400 REM scale reduction 1 to 0 -----------------------------------------------
6420 I= 9: GOSUB 10000: REM 80 char/line
6430 I= 9: GOSUB 10000
6440 I= 9: GOSUB 10000
6490 RETURN
6500 REM scale reduction cancel 0 to 1 ----------------------------------------
6520 I= 9: GOSUB 10000: REM 40 char/line
6530 I= 9: GOSUB 10000
6540 I=11: GOSUB 10000
6590 RETURN
6600 REM set number of lines per page -----------------------------------------
6620 I= 9: GOSUB 10000: REM max 255
6630 I= 9: GOSUB 10000
6640 C1=INT(C/100):C=C-100*C1
6645 C2=INT(C/10): C=C- 10*C2
6650 C3=C
6660 I=C1+48: GOSUB 10000
6665 I=C2+48: GOSUB 10000
6670 I=C3+48: GOSUB 10000
6680 I=13: GOSUB 10000
6690 RETURN
6700 REM line feed ------------------------------------------------------------
6720 I=10: GOSUB 10000: REM lf
6790 RETURN
6800 REM magnify scale 1 to 2 -------------------------------------------------
6820 I=11: GOSUB 10000: REM 26 char/line
6890 RETURN
6900 REM reduce  scale 2 to 1 -------------------------------------------------
6920 I=12: GOSUB 10000: REM 40 char/line
6990 RETURN
7000 REM carriage return ------------------------------------------------------
7020 I=13: GOSUB 10000: REM cr
7090 RETURN
7100 REM back space -----------------------------------------------------------
7120 I=14: GOSUB 10000: REM bs
7190 RETURN
7200 REM form feed ------------------------------------------------------------
7220 I=15: GOSUB 10000: REM ff
7290 RETURN
7300 REM next color -----------------------------------------------------------
7320 I=29: GOSUB 10000: REM text color
7390 RETURN
8000 REM controls used in graphicmode *****************************************
8010 REM draw circle ----------------------------------------------------------
8012 REM zeichne kreis um mittelpkt mx, my mit radius rad
8014 X=MX+RAD: Y=MY: GOSUB 8300: REM move pen to start
8016 I= 68: GOSUB 10000: REM draw
8020 FOR J=0 TO 360 STEP 10
8040 X=INT(COS(J*3.141593/180)*RAD+MX+.5)
8060 Y=INT(SIN(J*3.141593/180)*RAD+MY+.5)
8080 GOSUB 12000
8090 NEXT J
8095 RETURN
8100 REM draw line to x y -----------------------------------------------------
8102 REM ziehe linie vom momentanen punkt zum absoluten punkt x, y
8110 I=68: GOSUB 10000: REM c d
8120 GOSUB 12000: REM line
8130 I=13: GOSUB 10000: REM cr
8190 RETURN
8200 REM draw line rel x y ----------------------------------------------------
8202 REM ziehe linie vom momentanen punkt relativ +-x, +-y
8210 I=74: GOSUB 10000: REM c j
8220 GOSUB 12000: REM line
8230 I=13: GOSUB 10000: REM cr
8290 RETURN
8300 REM move pen  to x y -----------------------------------------------------
8302 REM bewege stift ohne zeichnen zum absoluten punkt x, y
8310 I=77: GOSUB 10000: REM c m
8320 GOSUB 12000: REM line
8330 I=13  :GOSUB 10000:
8390 RETURN
8400 REM move pen rel x y -----------------------------------------------------
8402 REM bewege stift ohne zeichnen vom momentanen punkt +-x, +-y
8410 I=82: GOSUB 10000: REM c r
8430 GOSUB 12000: REM line
8440 I=13      :GOSUB 10000:
8490 RETURN
8500 REM line-type ------------------------------------------------------------
8502 REM definiere linientyp: 0= durchgehend, 1-15: gestrichelt
8510 I=76: GOSUB 10000: REM c l
8520 I=INT(C/10): I=I+48: GOSUB 10000
8530 I=C-10*INT(C/10): I=I+48: GOSUB 10000
8540 I=13      :GOSUB 10000:
8590 RETURN
8600 REM draw y-axis ----------------------------------------------------------
8602 REM zeichne y-achse:
8604 REM fa=factor: anzahl punkte bis zur naechsten markierung -999...999
8606 REM ma=marks : anzahl der markierungspunkte 1...255
8608 REM laenge der achse: factor*marks
8610 I=88: GOSUB 10000: I=48: GOSUB 10000: REM y-axis
8612 I=13: GOSUB 10000:REM cr
8620 F1=INT(FA/100):FA=FA-100*F1
8621 F2=INT(FA/10): FA=FA- 10*F2
8622 F3=FA
8623 I=F1+48: GOSUB 10000
8624 I=F2+48: GOSUB 10000
8625 I=F3+48: GOSUB 10000
8628 I=13: GOSUB 10000:REM cr
8630 M1=INT(MA/100):MA=MA-100*M1
8631 M2=INT(MA/10): MA=MA- 10*M2
8632 M3=MA
8633 I=M1+48: GOSUB 10000
8634 I=M2+48: GOSUB 10000
8635 I=M3+48: GOSUB 10000
8638 I=13: GOSUB 10000:REM cr
8640 RETURN
8650 REM draw x-axis ----------------------------------------------------------
8652 REM zeichne x-achse:
8654 REM fa=factor: anzahl punkte bis zur naechsten markierung -999...999
8656 REM ma=marks : anzahl der markierungspunkte 1...255
8658 REM laenge der achse: factor*marks
8660 I=88: GOSUB 10000: I=49: GOSUB 10000: REM y-axis
8690 GOTO 8612: REM weiter wie y-axis
8700 REM color change ---------------------------------------------------------
8702 REM waehle farbe aus: 0: schwarz, 1: blau, 2: gruen, 3: rot
8710 I=67: GOSUB 10000: REM c c
8720 I=C+48:GOSUB 10000:
8730 I=13  :GOSUB 10000:
8790 RETURN
8800 REM set scale ------------------------------------------------------------
8802 REM waehle mass-stab-factor fuer text in grafik aus: 0(klein)-63(gross)
8810 I=83: GOSUB 10000: REM c s
8820 I=INT(C/10): C=C- 10*I: I=I+48: GOSUB 10000
8830 I=C+48: GOSUB 10000
8840 I=13  : GOSUB 10000:
8890 RETURN
8900 REM char rotate ----------------------------------------------------------
8902 REM waehle richtung fuer textdarstellung in grafik aus:
8904 REM 0:normal, 1:90 grad , 2:180 grad, 3:270 grad gedreht
8910 I=81: GOSUB 10000: REM c q
8920 I=C+48:GOSUB 10000:
8930 I=13  :GOSUB 10000:
8990 RETURN
9000 REM move pen home --------------------------------------------------------
9020 I=72: GOSUB 10000: REM home pos
9090 RETURN
9100 REM set new origin -------------------------------------------------------
9120 I=73: GOSUB 10000: REM set 0,0
9190 RETURN
9200 REM return to textmode ---------------------------------------------------
9220 I=65: GOSUB 10000: REM initialize
9290 RETURN
9300 REM init print characters ------------------------------------------------
9320 I=80: GOSUB 10000: REM c p
9340 REM alle folgenden ascii-zeichen drucken, bis cr (13) abschliesst
9390 RETURN
10000 REM centronics ausgabe **************************************************
10010 REM ********************************************************************
10020 REM LPT=&H278 bzw LPT=&H378 fuer LPT1 / LPT2 oder LPT=&H3BC (Hercules)
10030 LPT=&H278: REM achtung: auswahl der centronics-schnittstelle !!!
10040 REM ********************************************************************
10060 TEST=INP(LPT+1): REM priplo =busy ?
10080 IF (TEST AND &H80)=0 THEN 10060
10100 OUT LPT,I: REM daten-ausgabe
10120 OUT (LPT+2),0: REM strobe auf 1 (hardware-inverter)
10140 OUT (LPT+2),1: REM strobe auf 0 (hardware-inverter)
10180 RETURN
12000 REM Wandle Koordinaten in ASCII und gib an Centronics aus
12010 XV=SGN(X):X=ABS(X)
12020 X1=INT(X/100):X=X-100*X1
12030 X2=INT(X/10): X=X- 10*X2
12040 X3=X
12045 YV=SGN(Y):Y=ABS(Y)
12050 Y1=INT(Y/100):Y=Y-100*Y1
12060 Y2=INT(Y/10): Y=Y-10*Y2
12070 Y3=Y
12090 I=X1+48: GOSUB 10000
12100 I=X2+48: GOSUB 10000
12110 I=X3+48: GOSUB 10000
12120 REM bei x=negativ: minuszeichen
12125 IF XV=-1 THEN I=45: GOSUB 10000
12130 I=13:    GOSUB 10000
12190 I=Y1+48: GOSUB 10000
12200 I=Y2+48: GOSUB 10000
12210 I=Y3+48: GOSUB 10000
12220 REM bei y=negativ: minuszeichen
12225 IF YV=-1 THEN I=45: GOSUB 10000
12230 I=13:    GOSUB 10000
12490 RETURN
