1000 REM mz-demo2.bas",a
1020 REM                                                     7.12.89 12:58 lh
1100 REM ********************************************************************
1120 REM LPT=&H278 bzw LPT=&H378 fuer LPT1 / LPT2 oder LPT=&H3BC (Hercules)
1130 REM Achtung: auswahl der centronics-schnittstelle !!!
1140 LPT=&H278: GOTO 1180: REM Basisadresse (z.B.) LPT1
1142 LPT=&H378: GOTO 1180: REM Basisadresse (z.B.) LPT2
1144 LPT=&H3BC:            REM Basisadresse (z.B.) Hercules-Grafikkarte
1160 REM ********************************************************************
1180 PRINT"DEMO2 gestartet"
1200 OUT (LPT+2),1: REM strobe auf 0 (hardware-inverter)
1520 REM priplo auf textmode **********
1540 I=1: GOSUB 10000
1560 REM priplo auf grafikmode ********
1580 I=2: GOSUB 10000
1590 GOSUB 17000: REM draw voelkner
4180 I=72: GOSUB 10000: REM home pos
4200 I=13: GOSUB 10000: REM cr
5990 SYSTEM
6000 REM subroutines priplo control *******************************************
6020 REM controls used in textmode ****
6030 REM set priplo to textmode -----------------------------------------------
6040 I= 1: GOSUB 10000: REM textmode
6090 RETURN
6100 REM set priplo to graphicmode --------------------------------------------
6120 I= 2: GOSUB 10000: REM graphic
6190 RETURN
6200 REM line up --------------------------------------------------------------
6220 I= 3: GOSUB 10000: REM line up
6290 RETURN
6300 REM pen test -------------------------------------------------------------
6320 I= 4: GOSUB 10000: REM draw pattern
6390 RETURN
6400 REM scale reduction 1 to 0 -----------------------------------------------
6420 I= 9: GOSUB 10000: REM 80 char/line
6430 I= 9: GOSUB 10000
6440 I= 9: GOSUB 10000
6490 RETURN
6500 REM scale reduction cancel 0 to 1 ----------------------------------------
6520 I= 9: GOSUB 10000: REM 40 char/line
6530 I= 9: GOSUB 10000
6540 I=11: GOSUB 10000
6590 RETURN
6600 REM set number of lines per page -----------------------------------------
6620 I= 9: GOSUB 10000: REM max 255
6630 I= 9: GOSUB 10000
6640 C1=INT(C/100):C=C-100*C1
6645 C2=INT(C/10): C=C- 10*C2
6650 C3=C
6660 I=C1+48: GOSUB 10000
6665 I=C2+48: GOSUB 10000
6670 I=C3+48: GOSUB 10000
6680 I=13: GOSUB 10000
6690 RETURN
6700 REM line feed ------------------------------------------------------------
6720 I=10: GOSUB 10000: REM lf
6790 RETURN
6800 REM magnify scale 1 to 2 -------------------------------------------------
6820 I=11: GOSUB 10000: REM 26 char/line
6890 RETURN
6900 REM reduce  scale 2 to 1 -------------------------------------------------
6920 I=12: GOSUB 10000: REM 40 char/line
6990 RETURN
7000 REM carriage return ------------------------------------------------------
7020 I=13: GOSUB 10000: REM cr
7090 RETURN
7100 REM back space -----------------------------------------------------------
7120 I=14: GOSUB 10000: REM bs
7190 RETURN
7200 REM form feed ------------------------------------------------------------
7220 I=15: GOSUB 10000: REM ff
7290 RETURN
7300 REM next color -----------------------------------------------------------
7320 I=29: GOSUB 10000: REM text color
7390 RETURN
8000 REM controls used in graphicmode *****************************************
8010 REM draw circle ----------------------------------------------------------
8012 REM zeichne kreis um mittelpkt mx, my mit radius rad
8014 X=MX+RAD: Y=MY: GOSUB 8300: REM move pen to start
8016 I= 68: GOSUB 10000: REM draw
8020 FOR J=0 TO 360 STEP 10
8040 X=INT(COS(J*3.141593/180)*RAD+MX+.5)
8060 Y=INT(SIN(J*3.141593/180)*RAD+MY+.5)
8080 GOSUB 12000
8090 NEXT J
8095 RETURN
8100 REM draw line to x y -----------------------------------------------------
8102 REM ziehe linie vom momentanen punkt zum absoluten punkt x, y
8110 I=68: GOSUB 10000: REM c d
8120 GOSUB 12000: REM line
8130 I=13: GOSUB 10000: REM cr
8190 RETURN
8200 REM draw line rel x y ----------------------------------------------------
8202 REM ziehe linie vom momentanen punkt relativ +-x, +-y
8210 I=74: GOSUB 10000: REM c j
8220 GOSUB 12000: REM line
8230 I=13: GOSUB 10000: REM cr
8290 RETURN
8300 REM move pen  to x y -----------------------------------------------------
8302 REM bewege stift ohne zeichnen zum absoluten punkt x, y
8310 I=77: GOSUB 10000: REM c m
8320 GOSUB 12000: REM line
8330 I=13  :GOSUB 10000:
8390 RETURN
8400 REM move pen rel x y -----------------------------------------------------
8402 REM bewege stift ohne zeichnen vom momentanen punkt +-x, +-y
8410 I=82: GOSUB 10000: REM c r
8430 GOSUB 12000: REM line
8440 I=13      :GOSUB 10000:
8490 RETURN
8500 REM line-type ------------------------------------------------------------
8502 REM definiere linientyp: 0= durchgehend, 1-15: gestrichelt
8510 I=76: GOSUB 10000: REM c l
8520 I=INT(C/10): I=I+48: GOSUB 10000
8530 I=C-10*INT(C/10): I=I+48: GOSUB 10000
8540 I=13      :GOSUB 10000:
8590 RETURN
8600 REM draw y-axis ----------------------------------------------------------
8602 REM zeichne y-achse:
8604 REM fa=factor: anzahl punkte bis zur naechsten markierung -999...999
8606 REM ma=marks : anzahl der markierungspunkte 1...255
8608 REM laenge der achse: factor*marks
8610 I=88: GOSUB 10000: I=48: GOSUB 10000: REM y-axis
8612 I=13: GOSUB 10000:REM cr
8620 F1=INT(FA/100):FA=FA-100*F1
8621 F2=INT(FA/10): FA=FA- 10*F2
8622 F3=FA
8623 I=F1+48: GOSUB 10000
8624 I=F2+48: GOSUB 10000
8625 I=F3+48: GOSUB 10000
8628 I=13: GOSUB 10000:REM cr
8630 M1=INT(MA/100):MA=MA-100*M1
8631 M2=INT(MA/10): MA=MA- 10*M2
8632 M3=MA
8633 I=M1+48: GOSUB 10000
8634 I=M2+48: GOSUB 10000
8635 I=M3+48: GOSUB 10000
8638 I=13: GOSUB 10000:REM cr
8640 RETURN
8650 REM draw x-axis ----------------------------------------------------------
8652 REM zeichne x-achse:
8654 REM fa=factor: anzahl punkte bis zur naechsten markierung -999...999
8656 REM ma=marks : anzahl der markierungspunkte 1...255
8658 REM laenge der achse: factor*marks
8660 I=88: GOSUB 10000: I=49: GOSUB 10000: REM y-axis
8690 GOTO 8612: REM weiter wie y-axis
8700 REM color change ---------------------------------------------------------
8702 REM waehle farbe aus: 0: schwarz, 1: blau, 2: gruen, 3: rot
8710 I=67: GOSUB 10000: REM c c
8720 I=C+48:GOSUB 10000:
8730 I=13  :GOSUB 10000:
8790 RETURN
8800 REM set scale ------------------------------------------------------------
8802 REM waehle mass-stab-factor fuer text in grafik aus: 0(klein)-63(gross)
8810 I=83: GOSUB 10000: REM c s
8820 I=INT(C/10): C=C- 10*I: I=I+48: GOSUB 10000
8830 I=C+48: GOSUB 10000
8840 I=13  : GOSUB 10000:
8890 RETURN
8900 REM char rotate ----------------------------------------------------------
8902 REM waehle richtung fuer textdarstellung in grafik aus:
8904 REM 0:normal, 1:90 grad , 2:180 grad, 3:270 grad gedreht
8910 I=81: GOSUB 10000: REM c q
8920 I=C+48:GOSUB 10000:
8930 I=13  :GOSUB 10000:
8990 RETURN
9000 REM move pen home --------------------------------------------------------
9020 I=72: GOSUB 10000: REM home pos
9090 RETURN
9100 REM set new origin -------------------------------------------------------
9120 I=73: GOSUB 10000: REM set 0,0
9190 RETURN
9200 REM return to textmode ---------------------------------------------------
9220 I=65: GOSUB 10000: REM initialize
9290 RETURN
9300 REM init print characters ------------------------------------------------
9320 I=80: GOSUB 10000: REM c p
9340 REM alle folgenden ascii-zeichen drucken, bis cr (13) abschliesst
9390 RETURN
10000 REM centronics ausgabe **************************************************
10020 REM LPT=&H278, ggf. auf centronics-anschluss ihres rechners einstellen!
10060 TEST=INP(LPT+1): REM priplo =busy ?
10080 IF (TEST AND &H80)=0 THEN 10060
10100 OUT LPT,I: REM daten-ausgabe
10120 OUT (LPT+2),0: REM strobe auf 1 (hardware-inverter)
10140 OUT (LPT+2),1: REM strobe auf 0 (hardware-inverter)
10180 RETURN
12000 REM Wandle Koordinaten in ASCII und gib an Centronics aus
12010 XV=SGN(X):X=ABS(X)
12020 X1=INT(X/100):X=X-100*X1
12030 X2=INT(X/10): X=X- 10*X2
12040 X3=X
12045 YV=SGN(Y):Y=ABS(Y)
12050 Y1=INT(Y/100):Y=Y-100*Y1
12060 Y2=INT(Y/10): Y=Y-10*Y2
12070 Y3=Y
12090 I=X1+48: GOSUB 10000
12100 I=X2+48: GOSUB 10000
12110 I=X3+48: GOSUB 10000
12120 REM bei x=negativ: minuszeichen
12125 IF XV=-1 THEN I=45: GOSUB 10000
12130 I=13:    GOSUB 10000
12190 I=Y1+48: GOSUB 10000
12200 I=Y2+48: GOSUB 10000
12210 I=Y3+48: GOSUB 10000
12220 REM bei y=negativ: minuszeichen
12225 IF YV=-1 THEN I=45: GOSUB 10000
12230 I=13:    GOSUB 10000
12490 RETURN
17000 REM demo voelkner -------------------------------------------------------
17010 REM color black  ****************
17020 C=0: GOSUB 8700
17030 REM solid line   ****************
17040 C=0: GOSUB 8500
17100 REM move pen to 166,  0 *********
17110 X= 166:Y=   0: GOSUB 8300
17120 REM set scale factor       ******
17130 C=4: GOSUB 8800
17140 REM text
17150 I=80: GOSUB 10000: REM c p
17160 I=69: GOSUB 10000: REM c e
17170 I=76: GOSUB 10000: REM c l
17180 I=69: GOSUB 10000: REM c e
17190 I=67: GOSUB 10000: REM c c
17200 I=84: GOSUB 10000: REM c t
17210 I=82: GOSUB 10000: REM c r
17220 I=79: GOSUB 10000: REM c o
17230 I=78: GOSUB 10000: REM c n
17240 I=73: GOSUB 10000: REM c i
17250 I=67: GOSUB 10000: REM c c
17260 I=13: GOSUB 10000: REM cr
18000 REM draw voelkner in gross
18010 REM color blue   ****************
18020 C=1: GOSUB 8700
18025 I=72: GOSUB 10000: REM GOTO ORIGIN
18030 REM move pen to 0, -100 *********
18040 X=   0:Y=-100: GOSUB 8300
18050 I=73: GOSUB 10000: REM set origin
18060 REM v
18070 REM move pen to  76,  0    ******
18080 X= 76: Y=  0: GOSUB 8300
18090 REM line nach  76, 80 ***********
18100 X= 76: Y= 80: GOSUB 8100
18110 REM line nach  68, 80 ***********
18120 X= 68: Y= 80: GOSUB 8100
18130 REM line nach  68, 22 ***********
18140 X= 68: Y= 22: GOSUB 8100
18150 REM line nach  11, 80 ***********
18160 X= 11: Y= 80: GOSUB 8100
18170 REM line nach   0, 80 ***********
18180 X=  0: Y= 80: GOSUB 8100
18190 REM line nach  76,  0 ***********
18200 X= 76: Y=  0: GOSUB 8100
18210 REM oe
18220 REM color red    ****************
18230 C=3: GOSUB 8700
18240 REM circles
18270 MX=121: MY=40: RAD=40: GOSUB 8000
18300 MX=121: MY=40: RAD=35: GOSUB 8000
18320 X=112: Y= 40: GOSUB 8300
18330 REM line nach 117, 40 ***********
18340 X=117: Y= 40: GOSUB 8100
18350 REM line nach 117, 76 ***********
18360 X=117: Y= 76: GOSUB 8100
18370 REM line nach 112, 76 ***********
18380 X=112: Y= 76: GOSUB 8100
18390 REM line nach 112, 40 ***********
18400 X=112: Y= 40: GOSUB 8100
18410 REM move pen to 126, 40    ******
18420 X=126: Y= 40: GOSUB 8300
18430 REM line nach 131, 40 ***********
18440 X=131: Y= 40: GOSUB 8100
18450 REM line nach 131, 76 ***********
18460 X=131: Y= 76: GOSUB 8100
18470 REM line nach 126, 76 ***********
18480 X=126: Y= 76: GOSUB 8100
18490 REM line nach 126, 40 ***********
18500 X=126: Y= 40: GOSUB 8100
18510 REM l
18520 REM color blue   ****************
18530 C=1: GOSUB 8700
18540 REM move pen to 166,  0    ******
18550 X=166: Y=  0: GOSUB 8300
18560 REM line nach 196,  0 ***********
18570 X=196: Y=  0: GOSUB 8100
18580 REM line nach 196,  8 ***********
18590 X=196: Y=  8: GOSUB 8100
18600 REM line nach 174,  8 ***********
18610 X=174: Y=  8: GOSUB 8100
18620 REM line nach 174, 80 ***********
18630 X=174: Y= 80: GOSUB 8100
18640 REM line nach 166, 80 ***********
18650 X=166: Y= 80: GOSUB 8100
18660 REM line nach 166,  0 ***********
18670 X=166: Y=  0: GOSUB 8100
18680 REM k
18690 REM move pen to 203,  0    ******
18700 X=203: Y=  0: GOSUB 8300
18710 REM line nach 211,  0 ***********
18720 X=211: Y=  0: GOSUB 8100
18730 REM line nach 211, 36 ***********
18740 X=211: Y= 36: GOSUB 8100
18750 REM line nach 249,  0 ***********
18760 X=249: Y=  0: GOSUB 8100
18770 REM line nach 261,  0 ***********
18780 X=261: Y=  0: GOSUB 8100
18790 REM line nach 222, 39 ***********
18800 X=222: Y= 39: GOSUB 8100
18810 REM line nach 261, 80 ***********
18820 X=261: Y= 80: GOSUB 8100
18830 REM line nach 249, 80 ***********
18840 X=249: Y= 80: GOSUB 8100
18850 REM line nach 211, 41 ***********
18860 X=211: Y= 41: GOSUB 8100
18870 REM line nach 211, 80 ***********
18880 X=211: Y= 80: GOSUB 8100
18890 REM line nach 203, 80 ***********
18900 X=203: Y= 80: GOSUB 8100
18910 REM line nach 203,  0 ***********
18920 X=203: Y=  0: GOSUB 8100
18930 REM n
18940 REM move pen to 266,  0    ******
18950 X=266: Y=  0: GOSUB 8300
18960 REM line nach 274,  0 ***********
18970 X=274: Y=  0: GOSUB 8100
18980 REM line nach 274, 58 ***********
18990 X=274: Y= 58: GOSUB 8100
19000 REM line nach 331,  0 ***********
19010 X=331: Y=  0: GOSUB 8100
19020 REM line nach 331, 80 ***********
19030 X=331: Y= 80: GOSUB 8100
19040 REM line nach 323, 80 ***********
19050 X=323: Y= 80: GOSUB 8100
19060 REM line nach 323, 22 ***********
19070 X=323: Y= 22: GOSUB 8100
19080 REM line nach 266, 80 ***********
19090 X=266: Y= 80: GOSUB 8100
19100 REM line nach 266,  0 ***********
19110 X=266: Y=  0: GOSUB 8100
19120 REM e
19130 REM move pen to 345, 36    ******
19140 X=345: Y= 36: GOSUB 8300
19150 REM line nach 414, 36 ***********
19160 X=414: Y= 36: GOSUB 8100
19170 REM line nach 414, 40 ***********
19180 X=414: Y= 40: GOSUB 8100
19190 REM setze priplo auf draw *******
19200 I=68: GOSUB 10000: REM c d
19210 FOR J=0 TO 340 STEP 10
19220 X=INT(COS(J*3.141593/180)*40+375.5)
19230 Y=INT(SIN(J*3.141593/180)*40+40.5)
19240 GOSUB 12000
19250 NEXT J
19260 REM line nach 402, 26 ***********
19270 X=402: Y= 26: GOSUB 8100
19280 REM move pen to 345, 44    ******
19290 X=345: Y= 44: GOSUB 8300
19300 REM line nach 405, 44 ***********
19305 X=405: Y= 44: GOSUB 8100
19310 REM setze priplo auf draw *******
19320 I=68: GOSUB 10000: REM c d
19330 FOR J= 5 TO 335 STEP 10
19340 X=INT(COS(J*3.141593/180)*32+375.5)
19350 Y=INT(SIN(J*3.141593/180)*32+40.5)
19360 GOSUB 12000
19370 NEXT J
19380 REM r
19390 REM move pen to 433, 40    ******
19400 X=433: Y= 40: GOSUB 8300
19410 REM line nach 468,  0 ***********
19420 X=468: Y=  0: GOSUB 8100
19430 REM line nach 480,  0 ***********
19440 X=480: Y=  0: GOSUB 8100
19450 REM line nach 451, 34 ***********
19460 X=451: Y= 34: GOSUB 8100
19470 REM setze priplo auf draw *******
19480 I=68: GOSUB 10000: REM c d
19490 FOR J=300 TO 360 STEP 10
19500 X=INT(COS(J*3.141593/180)*24+440.5)
19510 Y=INT(SIN(J*3.141593/180)*24+56.5)
19520 GOSUB 12000
19530 NEXT J
19540 FOR J=0 TO  90 STEP 10
19550 X=INT(COS(J*3.141593/180)*24+440.5)
19560 Y=INT(SIN(J*3.141593/180)*24+56.5)
19570 GOSUB 12000
19580 NEXT J
19590 REM line nach 420, 80 ***********
19600 X=420: Y= 80: GOSUB 8100
19610 REM line nach 420,  0 ***********
19620 X=420: Y=  0: GOSUB 8100
19630 REM line nach 428,  0 ***********
19640 X=428: Y=  0: GOSUB 8100
19650 REM line nach 428, 72 ***********
19660 X=428: Y= 72: GOSUB 8100
19670 REM move pen to 433, 40    ******
19680 X=433: Y= 40: GOSUB 8300
19690 REM line nach 440, 40 ***********
19700 X=440: Y= 40: GOSUB 8100
19710 REM setze priplo auf draw *******
19720 I=68: GOSUB 10000: REM c d
19730 FOR J=270 TO 360 STEP 10
19740 X=INT(COS(J*3.141593/180)*16+440.5)
19750 Y=INT(SIN(J*3.141593/180)*16+56.5)
19760 GOSUB 12000
19770 NEXT J
19780 FOR J=0 TO  90 STEP 10
19790 X=INT(COS(J*3.141593/180)*16+440.5)
19800 Y=INT(SIN(J*3.141593/180)*16+56.5)
19810 GOSUB 12000
19820 NEXT J
19830 REM line nach 428, 72 ***********
19840 X=428: Y= 72: GOSUB 8100
20000 REM demo voelkner
20010 REM color black  ****************
20020 C=0: GOSUB 8700
20030 REM move     to 166,  0 *********
20040 X= 166:Y=   0: GOSUB 8300
20050 REM move rel to   0,-80 *********
20060 X=   0:Y= -60: GOSUB 8400
20120 REM set scale factor       ******
20130 C=3: GOSUB 8800
20140 REM text
20150 I=80: GOSUB 10000: REM c p
20160 I=68: GOSUB 10000: REM c d
20170 I=69: GOSUB 10000: REM c e
20180 I=82: GOSUB 10000: REM c r
20190 I=32: GOSUB 10000: REM space
20200 I=70: GOSUB 10000: REM c f
20210 I=65: GOSUB 10000: REM c a
20220 I=67: GOSUB 10000: REM c c
20230 I=72: GOSUB 10000: REM c h
20240 I=77: GOSUB 10000: REM c m
20250 I=65: GOSUB 10000: REM c a
20260 I=82: GOSUB 10000: REM c r
20270 I=75: GOSUB 10000: REM c k
20280 I=84: GOSUB 10000: REM c t
20290 I=13: GOSUB 10000: REM cr
29990 RETURN
